#include <predef.h>
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <smarttrap.h>
#include <taskmon.h>
#include <crypto/ssl.h>
#include <crypto/certgen.h>
#include <hal.h>
extern "C"
{
	void UserMain(void * pd);
	void WriteWebStatus(int sock, PCSTR url);
}

const char * AppName="firefoxSSL";

void WriteWebStatus(int sock, PCSTR url)
  {
	writestring( sock, "HelloWorld\r\n");
  }

void CreateCertAndKey()
{
	 int bufLen = 50;
	 unsigned char buf[bufLen] = {0};
	 bool expired = SSL_IsCertExpired(HalGetDeviceCert(), HalGetDeviceCertLen(),HalGetDeviceFormat());
	 SSL_GetCnFromCert(HalGetDeviceCert(), HalGetDeviceCertLen(), buf, bufLen, HalGetDeviceFormat());
	 char cName[bufLen] = {0};
	 for(int i = 0 ; i < bufLen ; i++)
	 {
	 	cName[i] = (char) buf[i];
	 	if(buf[i] == '\0') break;
	 }
	 if(!expired && EthernetIP == AsciiToIp4(cName))
	 	return; // return if certificate is not expired and IP address matches with common name of the certificate

	HalEraseDeviceCertAndKey(); // erase previous generated certificate

    // Create a self-signed cert/key pair. These are stored internally on the module.

    AltNameEntry altNames[1]; //This was fixed by Jon from netburner regard subject alternate name issue of the certificate which is required by Chrome
    altNames[0].m_type = ALT_NAME_TYPE_IP;
    // Value: Numerical IP address: 192.168.0.186
    DWORD ip = (DWORD)EthernetIP;
    char altNameVal_1[] = {
    						(char)(ip >> 24) & 0xFF,
    						(char)(ip >> 16) & 0xFF,
    						(char)(ip >> 8) & 0xFF,
    						(char)(ip >> 0) & 0xFF
    					  };
    altNames[0].m_value = altNameVal_1;
    altNames[0].m_len = sizeof(altNameVal_1) / sizeof(altNameVal_1[0]);

//    altNames[1].m_type = ALT_NAME_TYPE_DNS;
//    // Value: String IP address: "192.168.0.186"
//    char altNameVal_2[] = { 0x31, 0x39, 0x32, 0x2e, 0x31, 0x36, 0x38, 0x2e, 0x30, 0x2e, 0x31, 0x38, 0x36 };
//    altNames[1].m_value = altNameVal_2;
//    altNames[1].m_len = 13;

    char ipBuf[16]; //common name
    EthernetIP.sprintf(ipBuf, 16);
    SSL_CreateNewSelfSignedCert(ipBuf, altNames, 1);
}

void UserMain(void * pd) {
    InitializeStack();
    GetDHCPAddressIfNecessary();
    OSChangePrio(MAIN_PRIO);
    EnableAutoUpdate();
    StartHTTPs();
    EnableTaskMonitor();

    #ifndef _DEBUG
    EnableSmartTraps();
    #endif

    if(EthernetIP != 0)
	{
    	CreateCertAndKey(); // create server certificate and key
	}

    iprintf("Application started\n");

    while (1) {
        OSTimeDly(TICKS_PER_SECOND);
        iprintf("Sec since boot: %d\r\n", TimeTick / TICKS_PER_SECOND);
    }
}
